package org.wso2.carbon.application.deployer.schedule;

import org.wso2.carbon.application.deployer.ApplicationManager;
import org.wso2.carbon.application.deployer.AppDeployerUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.File;


public class ApplicationListener {

    private static final Log log = LogFactory.getLog(ApplicationListener.class);

    private ApplicationManager appManager;

    public ApplicationListener(ApplicationManager appManager) {
        this.appManager = appManager;
    }

    /**
     * Searches the applications directory and if applications are found, those are handed over
     * to the ApplicationManager to deploy
     *
     * @param isStartup - indicates whether this is server startup or not
     */
    public void findApplications(boolean isStartup) {
        try {
            File appDir = new File(AppDeployerUtils.getApplicationLocation());
            File[] files = appDir.listFiles();

            if (files != null && files.length > 0) {
                for (File file : files) {
                    if (file.isDirectory()) {
                        // TODO - support apps as a set of dirs
                    } else if (AppDeployerUtils.getFileExtension(file.getName()).equals("jar")) {
                        this.appManager.deployCarbonApp(file.getAbsolutePath(), isStartup);
                    }
                }
            }
        } catch (Exception e) {
            log.error("Can't deploy Application", e);
        }
    }
}
