package org.wso2.carbon.application.deployer.schedule;

import java.util.TimerTask;

public class SchedulerTask implements Runnable {
    static final int SCHEDULED = 1;
    static final int CANCELLED = 2;
    final Object lock = new Object();
    int state = 0;
    TimerTask timerTask;
    private ApplicationListener appListener;

    /**
     * Creates a new scheduler task.
     */
    public SchedulerTask(ApplicationListener listener) {
        this.appListener = listener;
    }

    /**
     * Cancels this scheduler task.
     * <p/>
     * This method may be called repeatedly; the second and subsequent calls have no effect.
     *
     * @return Returns true if this task was already scheduled to run.
     */
    public boolean cancel() {
        synchronized (lock) {
            if (timerTask != null) {
                timerTask.cancel();
            }

            boolean result = (state == SCHEDULED);

            state = CANCELLED;

            return result;
        }
    }

    /**
     * The action to be performed by this scheduler task.
     */
    public void run() {
        this.appListener.findApplications(false);
    }
}
