/*                                                                             
 * Copyright 2004,2005 The Apache Software Foundation.                         
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.carbon.bridge;

import java.io.File;

/**
 * Interface used for Bundle creation. The implementors will make regular JAR files into
 * OSGi bundles
 */
public interface BundleCreator {

    /**
     * Create the bundle, and place it in the <code>targetDir</code> directory
     *
     * @param targetDir  The directory into which the created OSGi bundle needs to be placed into.
     */
    void create(File targetDir) ;
}
