package org.wso2.carbon.registry.core.utils;

import java.sql.Timestamp;

/**
 * Represents a log record
 */
public class LogRecord {

    private String resourcePath;
    private String userName;
    private Timestamp timestamp;
    private int action;
    private String actionData;
    private int tenantId;

    /**
     * Method to obtain the resource path.
     *
     * @return the resource path.
     */
    public String getResourcePath() {
        return resourcePath;
    }

    /**
     * Method to obtain the resource path.
     *
     * @param resourcePath the resource path.
     */
    public void setResourcePath(String resourcePath) {
        this.resourcePath = resourcePath;
    }

    /**
     * Method to obtain the username.
     *
     * @return the username.
     */
    public String getUserName() {
        return userName;
    }

    /**
     * Method to obtain the username.
     *
     * @param userName the username.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }

    /**
     * Method to obtain the timestamp.
     *
     * @return the timestamp.
     */
    public Timestamp getTimestamp() {
        return timestamp;
    }

    /**
     * Method to obtain the timestamp.
     *
     * @param timestamp the timestamp.
     */
    public void setTimestamp(Timestamp timestamp) {
        this.timestamp = timestamp;
    }

    /**
     * Method to obtain the action.
     *
     * @return the action.
     */
    public int getAction() {
        return action;
    }

    /**
     * Method to obtain the action.
     *
     * @param action the action.
     */
    public void setAction(int action) {
        this.action = action;
    }

    /**
     * Method to obtain the action data.
     *
     * @return the action data.
     */
    public String getActionData() {
        return actionData;
    }

    /**
     * Method to obtain the action data.
     *
     * @param actionData the action data.
     */
    public void setActionData(String actionData) {
        this.actionData = actionData;
    }

    /**
     * Method to obtain the tenant identifier.
     *
     * @return the tenant identifier.
     */
    public int getTenantId() {
        return tenantId;
    }

    /**
     * Method to set the tenant identifier.
     *
     * @param tenantId the tenant identifier.
     */
    public void setTenantId(int tenantId) {
        this.tenantId = tenantId;
    }

    /**
     * returns a string representation of this record.
     *
     * @return string representation of this record
     */
	public String toString() {
        return resourcePath + ":" + userName + ":" + action + ":" + actionData + ":" + tenantId;
	}	
	
}
