package org.wso2.carbon.user.core;

public class UserCoreConstants {
    
    public static final String DATA_SOURCE = "um.datasource";

    public static final short BEHAVIOUR_INHERITED = 0;
    public static final short BEHAVIOUR_HIDDEN = 1;
    public static final short BEHAVIOUR_OVERRIDDEN = 2;
    
    public static final String INTERNAL_USERSTORE = "Internal";
    public static final String EXTERNAL_USERSTORE = "External";

    public static final String DELEGATING_REALM = "Delegating";
    public static final String DEFAULT_REALM = "Default";
    public static final String HYBRID_REALM = "Hybrid";
    public static final String REALM_GENRE = "RealmGenre";
    public static final String DEFAULT_CARBON_DIALECT = "http://wso2.org/claims";
    
    public static short DENY = 0;
    public static short ALLOW = 1;
    
    public static String UM_TENANT_COLUMN = "UM_TENANT_ID";

    public static final String SYSTEM_RESOURCE = "System";
    public static final String MSSQL_TYPE = "mssql";
    
    public static final class RealmConfig {
        public static final String LOCAL_NAME_USER_MANAGER = "UserManager";
        public static final String LOCAL_NAME_REALM = "Realm";
        public static final String LOCAL_NAME_CONFIGURATION = "Configuration";
        public static final String LOCAL_NAME_PROPERTY = "Property";
        public static final String LOCAL_NAME_ADMIN_ROLE = "AdminRole";
        public static final String LOCAL_NAME_ADMIN_USER = "AdminUser";
        public static final String LOCAL_NAME_USER_NAME = "UserName";
        public static final String LOCAL_NAME_PASSWORD = "Password";
        public static final String LOCAL_NAME_AUTHENTICATOR = "Authenticator";
        public static final String LOCAL_NAME_USER_STORE_MANAGER = "UserStoreManager";
        public static final String LOCAL_NAME_ATHZ_MANAGER = "AuthorizationManager";
        public static final String LOCAL_NAME_SYSTEM_USER_NAME = "SystemUserName";
        public static final String LOCAL_NAME_EVERYONE_ROLE = "EveryOneRoleName";
        public static final String LOCAL_NAME_ANONYMOUS_USER = "AnonymousUser";
        public static final String LOCAL_NAME_READ_ONLY = "ReadOnly";
        public static final String LOCAL_NAME_MAX_USER_LIST_LIMIT = "MaxUserNameListLength";
        public static final String ATTR_NAME_CLASS = "class";
        public static final String ATTR_NAME_PROP_NAME = "name";
        public static final String PROPERTY_EVERYONEROLE_AUTHORIZATION = "EveryoneRoleManagementPermissions";
        public static final String PROPERTY_USERNAME_UNIQUE = "UserNameUniqueAcrossTenants";
        public static final String PROPERTY_IS_EMAIL_USERNAME = "IsEmailUserName";
        public static final String PROPERTY_DOMAIN_CALCULATION = "DomainCalculation";
        public static final String PROPERTY_IS_USERS_OF_ROLE_LISTING = "IsUsersOfRoleListing";
        
        public static final String PROPERTY_VALUE_DOMAIN_CALCULATION_DEFAULT = "default";
        public static final String PROPERTY_VALUE_DOMAIN_CALCULATION_CUSTOM = "custom";
        
        public static final String PROPERTY_JAVA_REG_EX = "PasswordJavaRegEx";
        public static final String PROPERTY_JS_REG_EX = "PasswordJavaScriptRegEx";
    }


    public static final String INVOKE_SERVICE_PERMISSION = "invoke-service";
    
    public static final String AUTHZ_CACHE = "AuthzCache";
    public static final String ROLE_CACHE = "RoleCache";

    public static final int MAX_OBJECTS_IN_CACHE = 5000;
    public static final int TTL_CACHE = 30;
    public static final int IDLE_TIME_IN_CACHE = 0;

    public static final String DEFAULT_PROFILE = "default";
    public static final String DEFAULT_PROFILE_CONFIGURATION = "default";
    public static final String PROFILE_CONFIGURATION = "profileConfiguration";
    public static final String PICTURE_CLAIM = "picture";

    public static final String CLAIM_HIDDEN = "Hidden";
    public static final String CLAIM_OVERRIDEN = "Overridden";
    public static final String CLAIM_INHERITED = "Inherited";

    public static final String AUTHORIZATION_ACTION_LOGIN = "login";
    public static final String AUTHORIZATION_ACTION_MANAGE_CONFIGURATION = "manage-configuration";
    public static final String AUTHORIZATION_ACTION_MANAGE_SECURITY = "manage-security";
   
    public static final String LOCAL_NAME_PROPERTY = "Property";
    
    public static final class ClaimTypeURIs {
        public static final String GIVEN_NAME = "/givenname";
        public static final String EMAIL_ADDRESS = DEFAULT_CARBON_DIALECT + "/emailaddress";
        public static final String SURNAME = DEFAULT_CARBON_DIALECT + "/lastname";
        public static final String STREET_ADDRESS = DEFAULT_CARBON_DIALECT + "/streetaddress";
        public static final String LOCALITY = DEFAULT_CARBON_DIALECT + "/locality";
        public static final String REGION = DEFAULT_CARBON_DIALECT + "/region";
        public static final String POSTAL_CODE = DEFAULT_CARBON_DIALECT + "/postalcode";
        public static final String COUNTRY = DEFAULT_CARBON_DIALECT + "/country";
        public static final String HONE = DEFAULT_CARBON_DIALECT + "/telephone";
        public static final String IM = DEFAULT_CARBON_DIALECT + "/im";
        public static final String ORGANIZATION = DEFAULT_CARBON_DIALECT + "/organization";
        public static final String URL = DEFAULT_CARBON_DIALECT + "/url";
        public static final String TITLE = DEFAULT_CARBON_DIALECT + "/title";
        public static final String ROLE = DEFAULT_CARBON_DIALECT + "/role";
        public static final String MOBILE = DEFAULT_CARBON_DIALECT + "/mobile";
        public static final String NICKNAME = DEFAULT_CARBON_DIALECT + "/nickname";
        public static final String DATE_OF_BIRTH = DEFAULT_CARBON_DIALECT + "/dob";
        public static final String GENDER = DEFAULT_CARBON_DIALECT + "/gender";
    }
}
