package org.wso2.carbon.user.core.authorization;

import java.util.ArrayList;
import java.util.List;

/**
 * The SearchResult holder
 */
class SearchResult {
    /**
     * This is an exact TreeNode match, or the last node found while
     * traversing the tree
     */
    private TreeNode lastNode;
    /**
     * The List of path segments not found on the tree, during the search
     */
    private List<String> unprocessedPaths;
    /**
     * The accumulated state of explicit permissions to the last node
     */
    private Boolean lastNodeAllowedAccess = Boolean.FALSE;

    private List<String> allowedEntities = new ArrayList<String>();
    private List<String> deniedEntities = new ArrayList<String>();

    SearchResult() {
    }

    SearchResult(TreeNode tn, List<String> up) {
        this.lastNode = tn;
        this.unprocessedPaths = up;
    }

    public TreeNode getLastNode() {
        return lastNode;
    }

    public void setLastNode(TreeNode lastNode) {
        this.lastNode = lastNode;
    }

    public List<String> getUnprocessedPaths() {
        return unprocessedPaths;
    }

    public void setUnprocessedPaths(List<String> unprocessedPaths) {
        this.unprocessedPaths = unprocessedPaths;
    }

    public Boolean getLastNodeAllowedAccess() {
        return lastNodeAllowedAccess;
    }

    public void setLastNodeAllowedAccess(Boolean lastNodeAllowedAccess) {
        this.lastNodeAllowedAccess = lastNodeAllowedAccess;
    }

    public List<String> getAllowedEntities() {
        return allowedEntities;
    }

    public void setAllowedEntities(List<String> allowedEntities) {
        this.allowedEntities = allowedEntities;
    }

    public List<String> getDeniedEntities() {
        return deniedEntities;
    }

    public void setDeniedEntities(List<String> deniedEntities) {
        this.deniedEntities = deniedEntities;
    }
}
