package org.wso2.carbon.user.core;

import java.util.HashMap;
import java.util.Map;

import org.wso2.carbon.user.core.claim.Claim;
import org.wso2.carbon.user.core.claim.ClaimMapping;
import org.wso2.carbon.user.core.profile.ProfileConfiguration;

public class ClaimTestUtil {
    
    public static final String CLAIM_URI1 = "http://wso2.org/givenname";
    public static final String CLAIM_URI2 = "http://wso2.org2/givenname2";
    public static final String CLAIM_URI3 = "http://wso2.org/givenname3";
    public static final String HOME_PROFILE_NAME = "HomeProfile";

    public static Map<String, ClaimMapping> getClaimTestData() {
        Map<String, ClaimMapping> claims = new HashMap<String, ClaimMapping>();
        Claim claim1 = new Claim();
        claim1.setClaimUri(CLAIM_URI1);
        claim1.setDescription("The description is nutts");
        claim1.setDialectURI("http://wso2.org/");
        claim1.setDisplayTag("Given Name");
        claim1.setRegEx("ty&*RegEx");
        claim1.setRequired(true);
        claim1.setSupportedByDefault(true);
        ClaimMapping cm1 = new ClaimMapping();
        cm1.setClaim(claim1);
        cm1.setMappedAttribute("attr1");
        claims.put("http://wso2.org/givenname", cm1);

        Claim claim2 = new Claim();
        claim2.setClaimUri(CLAIM_URI2);
        claim2.setDescription("The description is nutts2");
        claim2.setDialectURI("http://wso2.org2/");
        claim2.setDisplayTag("Given Name2");
        claim2.setRegEx("ty&*RegEx2");
        claim2.setRequired(true);
        claim2.setSupportedByDefault(true);
        ClaimMapping cm2 = new ClaimMapping();
        cm2.setClaim(claim2);
        cm2.setMappedAttribute("attr2");
        claims.put("http://wso2.org2/givenname2", cm2);

        Claim claim3 = new Claim();
        claim3.setClaimUri(CLAIM_URI3);
        claim3.setDescription("The description is nutts3");
        claim3.setDialectURI("http://wso2.org/");
        claim3.setDisplayTag("Given Name3");
        claim3.setRegEx("ty&*RegEx3");
        claim3.setRequired(true);
        claim3.setSupportedByDefault(true);
        ClaimMapping cm3 = new ClaimMapping();
        cm3.setClaim(claim3);
        cm3.setMappedAttribute("attr3");
        claims.put("http://wso2.org/givenname3", cm3);
     
        return claims;
        
    }

    public static Map<String, ProfileConfiguration> getProfileTestData() {
        Map<String, ProfileConfiguration> map = new HashMap<String, ProfileConfiguration>();
        ProfileConfiguration profConfig = new ProfileConfiguration();
        profConfig.setProfileName(HOME_PROFILE_NAME);
        profConfig.addHiddenClaim(CLAIM_URI1);
        profConfig.addInheritedClaim(CLAIM_URI2);
        profConfig.setDialectName("http://wso2.org/");
        map.put(HOME_PROFILE_NAME, profConfig);
        return map;
    }

}
