package org.wso2.carbon.user.mgt.ui;

import java.util.Arrays;

import javax.activation.DataHandler;
import javax.mail.util.ByteArrayDataSource;

import org.wso2.carbon.user.mgt.ui.types.carbon.ClaimValue;
import org.wso2.carbon.user.mgt.ui.types.carbon.FlaggedName;
import org.wso2.carbon.user.mgt.ui.types.carbon.UIPermissionNode;
import org.wso2.carbon.user.mgt.ui.types.carbon.UserStoreInfo;

public class Util {

    public static FlaggedName[] toADBFlaggedNames(
            org.wso2.carbon.user.mgt.common.FlaggedName[] flaggedNames) {
        if(flaggedNames == null){
            return new FlaggedName[0];
        }
        FlaggedName[] names = new FlaggedName[flaggedNames.length];
        int i = 0;
        for (org.wso2.carbon.user.mgt.common.FlaggedName fName : flaggedNames) {
            FlaggedName name = new FlaggedName();
            name.setItemName(fName.getItemName());
            name.setEditable(fName.isEditable());
            name.setSelected(fName.isSelected());
            names[i] = name;
            i++;
        }
        return names;
    }

    public static org.wso2.carbon.user.mgt.common.FlaggedName[] toCommonFlaggedNames(
            FlaggedName[] flaggedNames) {
        if(flaggedNames == null) {
            return new org.wso2.carbon.user.mgt.common.FlaggedName[0];
        }
        org.wso2.carbon.user.mgt.common.FlaggedName[] names = new org.wso2.carbon.user.mgt.common.FlaggedName[flaggedNames.length];
        int i = 0;
        for (FlaggedName fName : flaggedNames) {
            org.wso2.carbon.user.mgt.common.FlaggedName name = new org.wso2.carbon.user.mgt.common.FlaggedName();
            name.setItemName(fName.getItemName());
            name.setSelected(fName.getSelected());
            name.setEditable(fName.getEditable());
            names[i] = name;
            i++;
        }
        return names;
    }

    public static ClaimValue[] toADBClaimValues(
            org.wso2.carbon.user.mgt.common.ClaimValue[] claimValues) {
        if (claimValues == null) {
            return new ClaimValue[0];
        }
        ClaimValue[] values = new ClaimValue[claimValues.length];
        for (org.wso2.carbon.user.mgt.common.ClaimValue cvalue : claimValues) {
            ClaimValue value = new ClaimValue();
            value.setClaimURI(cvalue.getClaimURI());
            value.setValue(cvalue.getValue());
        }
        return values;
    }

    public static org.wso2.carbon.user.mgt.common.UserStoreInfo toCommonUserStoreInfo(
            UserStoreInfo userStoreInfo) {
        org.wso2.carbon.user.mgt.common.UserStoreInfo usInfo = new org.wso2.carbon.user.mgt.common.UserStoreInfo();
        usInfo.setAdminRole(userStoreInfo.getAdminRole());
        usInfo.setAdminUser(userStoreInfo.getAdminUser());
        usInfo.setAnonUser(userStoreInfo.getAnonUser());
        usInfo.setEveryOneRole(userStoreInfo.getEveryOneRole());
        usInfo.setReadOnly(userStoreInfo.getReadOnly());
        usInfo.setMaxUserListCount(userStoreInfo.getMaxUserListCount());
        usInfo.setJsRegEx(userStoreInfo.getJsRegEx());
        return usInfo;
    }

    public static org.wso2.carbon.user.mgt.common.FlaggedName[] buildFalggedArray(
            String[] shownUsers, String[] selectedUsers) {
        Arrays.sort(selectedUsers);
        org.wso2.carbon.user.mgt.common.FlaggedName[] flaggedNames = new org.wso2.carbon.user.mgt.common.FlaggedName[shownUsers.length];
        for (int i = 0; i < shownUsers.length; i++) {
            String name = shownUsers[i];
            org.wso2.carbon.user.mgt.common.FlaggedName flagName = new org.wso2.carbon.user.mgt.common.FlaggedName();
            flagName.setItemName(name);
            if (Arrays.binarySearch(selectedUsers, name) > -1) {
                flagName.setSelected(true);
            }
            flaggedNames[i] = flagName;
        }
        return flaggedNames;
    }

    public static org.wso2.carbon.user.mgt.common.UIPermissionNode toCommonUIPermissionNode(
            UIPermissionNode parentNode) {
        org.wso2.carbon.user.mgt.common.UIPermissionNode uiPermissionNode = new org.wso2.carbon.user.mgt.common.UIPermissionNode();
        uiPermissionNode.setDisplayName(parentNode.getDisplayName());
        uiPermissionNode.setResourcePath(parentNode.getResourcePath());
        uiPermissionNode.setSelected(parentNode.getSelected());
        org.wso2.carbon.user.mgt.common.UIPermissionNode[] children = null;
        if (parentNode.getNodeList() != null) {
            children = new org.wso2.carbon.user.mgt.common.UIPermissionNode[parentNode
                    .getNodeList().length];
            for (int i = 0; i < parentNode.getNodeList().length; i++) {
                org.wso2.carbon.user.mgt.common.UIPermissionNode child = toCommonUIPermissionNode(parentNode
                        .getNodeList()[i]);
                children[i] = child;

            }
        } else {
            children = new org.wso2.carbon.user.mgt.common.UIPermissionNode[0];
        }
        uiPermissionNode.setNodeList(children);
        return uiPermissionNode;
    }
    
    public static DataHandler buildDataHandler(byte[] content) {   
        DataHandler dataHandler = new DataHandler(new ByteArrayDataSource(content,
                "application/octet-stream"));
        return dataHandler;
    }
}
