package org.wso2.carbon.user.mgt;

import java.io.IOException;
import java.io.InputStream;

import javax.activation.DataHandler;

import org.wso2.carbon.core.AbstractAdmin;
import org.wso2.carbon.registry.core.Registry;
import org.wso2.carbon.registry.core.session.UserRegistry;
import org.wso2.carbon.user.mgt.common.ClaimValue;
import org.wso2.carbon.user.mgt.common.FlaggedName;
import org.wso2.carbon.user.mgt.common.IUserAdmin;
import org.wso2.carbon.user.mgt.common.UIPermissionNode;
import org.wso2.carbon.user.mgt.common.UserAdminException;
import org.wso2.carbon.user.mgt.common.UserStoreInfo;
import org.wso2.carbon.utils.WSO2Constants;

public class UserAdmin extends AbstractAdmin implements IUserAdmin {

    public UserAdmin() {

    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.UserAdmin#listInternalUsers(java.lang.String)
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#listUsers(java.lang.String)
     */
    public String[] listUsers(String filter) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        return userAdminCore.listUsers(filter);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.UserAdmin#getInternalRoles()
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#getAllRolesNames()
     */
    public FlaggedName[] getAllRolesNames() throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        return userAdminCore.getAllRolesNames();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#isWritable()
     */
    public UserStoreInfo getUserStoreInfo() throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        return userAdminCore.getUserStoreInfo();
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.UserAdmin#addUserToInternalStore(java.lang.String
     * , java.lang.String, java.lang.String[])
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#addUser(java.lang.String,
     * java.lang.String, java.lang.String[], java.util.Map, java.lang.String)
     */
    public void addUser(String userName, String password, String[] roles, ClaimValue[] claims,
            String profileName) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.addUser(userName, password, roles, claims, profileName);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.UserAdmin#changePassword(java.lang.String,
     * java.lang.String)
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#changePassword(java.lang.String,
     * java.lang.String)
     */
    public void changePassword(String userName, String newPassword) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.changePassword(userName, newPassword);
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.UserAdmin#deleteUserFromInternalStore(java.lang
     * .String)
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#deleteUser(java.lang.String)
     */
    public void deleteUser(String userName) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.deleteUser(userName, super.getConfigSystemRegistry());
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.UserAdmin#addRoleToInternalStore(java.lang.String
     * , java.lang.String[], java.lang.String[])
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#addRole(java.lang.String,
     * java.lang.String[], java.util.Map)
     */
    public void addRole(String roleName, String[] userList, String[] permissions)
            throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.addRole(roleName, userList, permissions);
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.UserAdmin#deleteRoleFromInternalStore(java.lang
     * .String)
     */
    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.TestClass#deleteRole(java.lang.String)
     */
    public void deleteRole(String roleName) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.deleteRole(roleName);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.UserAdmin#getUsersInRole(java.lang.String)
     */
    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.TestClass#getUsersInfoOfRole(java.lang.String,
     * java.lang.String)
     */
    public FlaggedName[] getUsersOfRole(String roleName, String filter) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        return userAdminCore.getUsersOfRole(roleName, filter);
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.UserAdmin#updateUsersOfRole(java.lang.String,
     * java.lang.String[], java.lang.String[])
     */
    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.TestClass#updateUsersOfRole(java.lang.String,
     * java.lang.String[], java.lang.String[])
     */
    public void updateUsersOfRole(String roleName, FlaggedName[] userList)
            throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.updateUsersOfRole(roleName, userList);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.wso2.carbon.user.mgt.UserAdmin#getUsersInRole(java.lang.String)
     */
    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.TestClass#getRoleInfoOfUser(java.lang.String)
     */
    public FlaggedName[] getRolesOfUser(String userName) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        return userAdminCore.getRolesOfUser(userName);
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.wso2.carbon.user.mgt.TestClass#updateRolesOfUser(java.lang.String,
     * java.lang.String)
     */
    public void updateRolesOfUser(String userName, String[] newUserList) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.updateRolesOfUser(userName, newUserList);
    }

    public UIPermissionNode getAllUIPermissions() throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        Registry registry = (Registry) getConfigContext().getAxisConfiguration().getParameterValue(
                WSO2Constants.CONFIG_SYSTEM_REGISTRY_INSTANCE);
        int tenantId = ((UserRegistry) registry).getTenantId();
        return userAdminCore.getAllUIPermissions(tenantId, registry);
    }

    public UIPermissionNode getRolePermissions(String roleName) throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        Registry registry = (Registry) getConfigContext().getAxisConfiguration().getParameterValue(
                WSO2Constants.CONFIG_SYSTEM_REGISTRY_INSTANCE);
        int tenantId = ((UserRegistry) registry).getTenantId();
        return userAdminCore
                .getRolePermissions(roleName, tenantId, super.getConfigSystemRegistry());
    }

    public void setRoleUIPermission(String roleName, String[] rawResources)
            throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.setRoleUIPermission(roleName, rawResources);
    }

    public void bulkImportUsers(String fileName, DataHandler handler, String defaultPassword)
            throws UserAdminException {
        if(fileName == null || handler == null || defaultPassword == null) {
            throw new UserAdminException("Required data not provided");
        }
        try {
            UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
            InputStream inStream = handler.getInputStream();
            userAdminCore.bulkImportUsers(fileName, inStream, defaultPassword);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public void changePasswordByUser(String oldPassword, String newPassword)
            throws UserAdminException {
        UserRealmProxy userAdminCore = new UserRealmProxy(super.getUserRealm());
        userAdminCore.changePasswordByUser(oldPassword, newPassword);
    }

}
